<script setup lang="ts">
import { onMounted, ref } from 'vue'
import GitApiCall from '@/api/gitApi'

// Define interface for the dashboard items
interface Dashboard {
  title: string
  description: string
  short_description: string
  date: string
  href: string
}

const dashboardsData = ref<Dashboard[]>([])

const getDashboardsContent = async () => {
  const git = new GitApiCall()

  console.log('getDashboardsContent uiBackendProject:', git.uiBackendProject)
  try {
    const response = await git.getFileContent(git.uiBackendProject, 'dashboards.json/raw?ref=main')

    dashboardsData.value = response.data
    console.log('getDashboardsContent:', dashboardsData.value)
  }
  catch (error) {
    console.error('ERROR getDashboardsContent', error)
  }
}

onMounted(() => {
  getDashboardsContent()
})
</script>

<template>
  <VList>
    <VListGroup>
      <VListItem
        v-for="(dashboard, index) in dashboardsData"
        :key="index"
        :href="dashboard.href"
        target="_blank"
        rel="noopener noreferrer"
        two-line
        class="flex-column align-items-start"
      >
        <template #default="{ active, toggle }">
          <VListItemContent>
            <VListItemTitle>
              {{ dashboard.title }}
            </VListItemTitle>
            <VListItemSubtitle>
              {{ dashboard.date }}
            </VListItemSubtitle>
            <div class="d-flex w-100 justify-content-between">
              <p class="mb-1">
                {{ dashboard.description }}
              </p>
              <small class="text-secondary">{{ dashboard.short_description }}</small>
            </div>
          </VListItemContent>
        </template>
      </VListItem>
    </VListGroup>
  </VList>
</template>
